; ****************************************************************************
; * Program & Code: Copyright (C) 1988 by AFI COMMUNICATIONS and Dan Thomson *
; * Use  of this Code by any person,  for any reason except the  compilation *
; * of AFI Communications Software is prohibited & strictly forbiden by Law. *
; ****************************************************************************
;
;     Compiled using Turbo Assembler Version 1.0 By Borland International
;

title  Male.Asm
page,132
	
;
; Although written for and compiled with TASM 1.0, this program
; should re-compile with MASM 5.1 (I don't have an earlier version
; so can't speak for them.)
;
; To compile with TASM:
;			TASM male
;			TLINK /t male
; (This creates a .com file)
;
; To compile with MASM:
;			MASM male;
;			LINK male;
;			EXE2BIN male.exe male.com

true	equ	0ffh
false	equ	00h
cr	equ	0dh
lf	equ	0ah
blank	equ	20h
tab	equ	09h
cmdtail	equ	80h
stdout	equ	1
stderr	equ	2


CSEG	segment PARA PUBLIC 'CODE'
	assume	CS:CSEG,DS:CSEG,ES:CSEG,SS:CSEG	;Already set by DOS loader

	org	100h				;All .coms start at $100
start:	jmp	male				;Skip past data

syntax	db	lf,'<M>ake <A> <L>og <E>ntry, Revision: 1.00 - Copyright (c) 1988 by Dan Thomson',cr,lf,lf
	db	'Usage:  MALE <Priority> <Log Entry> [>>Log File]',cr,lf,lf
	db	'  <Priority>  = !, #, +, :, or *',cr,lf
	db	'  <Log Entry> = What you want in the log',cr,lf
	db	'  [Log File]  = Where you want the entry sent',cr,lf,lf
	db	'MALE always sends the log entries to Standard Output.',cr,lf
	db	'If no Priority symbol is given, a blank space will be used.',cr,lf
syn_len	equ	$-syntax

months	db	'JanFebMarAprMayJun'
	db	'JulAugSepOctNovDec'
log 	db	'  '				; 2 characters
day	db	'       '			; 7 characters
time	db	'??:??:?? '			; 9 characters
line	db	61 dup (?)			; Buffer to hold log entry


male	proc	near

	mov	BX,cmdtail			;ES:BX = command parameters
	call	argc				;Get number of arguments
 	cmp	AX,3				;At least 2 arguments?
	jae	args_ok				;If yes, keep going

; A problem exists with argument count. Display usage
; message and then exit the program.

usage:	mov	DX,offset syntax		;Point to usage string
	mov	CX,syn_len			;Get length in CX
	mov	BX,stderr			;Output to standard error
	mov	AH,40h				;AH = Write to device
	int	21h				;Call DOS to do it

	mov	AL,1				;Errorlevel 1
back_to_dos:
	mov	AH,4ch				;Terminate with error code
	int	21h				;Exit to DOS (for good)

args_ok:

; Now we get the system date and time and patch it into our
; log entry line.

	mov	AH,2ah				;AH = Get Date
	int	21h				;Call DOS

	mov	SI,offset day			;Storage for date
	mov	AL,DL				;Get day in AL
	call    b2asc				;Convert to ASCII and store

	mov	DI,offset day+3			;Storage for month
	mov	SI,offset months-3		;Point to month table
	xor	BH,BH				;BH = null
	mov	BL,DH				;Get month number in BL
	mov	AL,3				;Length of month names
	mul	BL				;Multiply to find right month
	mov	BL,AL				;Get answer in BL
	mov	CX,3				;Length of month
	lea	SI,[SI+BX]			;Point to proper month
	rep	movsb				;Add it to our line

; The date has been done, lets do the time now...

	mov	AH,2ch				;AH = Get System Time
	int	21h				;Call DOS to do it

	mov	SI,offset time			;Storage for ASCII time
	mov	AL,CH				;Convert hours
	call    b2asc

	mov	AL,CL				;Convert minutes
	add	SI,3
	call	b2asc

	mov	AL,DH				;Convert seconds
	add	SI,3
	call	b2asc

	xor	CH,CH				;Zero to high byte
	mov	SI,cmdtail			;Point to command tail
	mov	CL,byte ptr [SI]		;Get length of argument

	mov	SI,cmdtail+1			;Point to argument
	call	get_bang			;Move in the entry identifier
	push	CX				;Save number of characters

	cmp	CL,58				;More than 60 characters?
	jb	ok				;Nope, All is well
	mov	CL,58				;Else we only take 60
	pop	AX
	push	CX

ok:	mov	DI,offset line			;Point to our buffer
	rep	movsb				;Mov the stuff to buffer
	pop	CX				;Get char counter back
	cmp	byte ptr [DI-1],cr		;Was last char a cr?
	je	ok1				;If yes, don't put one in
	mov	AL,cr				;Add a carriage return
	stosb
	inc	CX				;Bump char counter
ok1:	mov	AL,lf				;Add a line feed
	stosb
	inc	CX				;Bump char counter
	add	CL,18				;Add time/date chars

	mov	DX,offset log			;Point to screen info
	mov	BX,stdout			;Out to standard error
	mov	AH,40h				;Write to device
	int	21h				;Call DOS to do it

male	endp


; Return number of command line arguments given.
;
; Call with DS:BX = command tail (DS:80h)
; Returns AX = Number of arguments
 
argc	proc	near				;count command line arguments

	mov	ax,1				;force count >= 1
argc1:	mov	cx,-1				;set flag = outside argument
argc2:	inc	bx				;point to next character
	cmp	byte ptr [bx],cr
	je	argc3				;exit if carriage return
	cmp	byte ptr [bx],blank
	je	argc1				;outside argument if ASCII blank
	cmp	byte ptr [bx],tab
	je	argc1				;outside argument if ASCII tab
						;otherwise not blank or tab,
	jcxz	argc2				;jump if inside argument

	inc	ax				;else found argument, count it
	not	cx				;set flag = inside argument
	jmp	argc2				;and look at next character

argc3:	ret					;return AX = argument count

argc	endp


b2asc	proc    near            ; convert binary 0-99
                                ; to two ASCII digits.
                                ; AL    = value
                                ; DS:SI = storage address
                                ; destroys AX 

        aam                     ; divide AL by 10 ->
                                ; AH = quot., AL = rem.

        add     ax,'00'         ; convert to ASCII
        xchg    ah,al
        mov     [si],ax         ; and store digits

        ret                     ; back to caller

b2asc	endp

get_bang	proc	near

	inc	CX				;Adjust for next instruction
@@GB1:	dec	CX				;Chars = Chars - 1
	lodsb					;Get char from command line
	cmp	AL,blank			;Is it a space?
	je	@@GB1				;Go back if yes
	cmp	AL,tab				;Is it a tab character?
	je	@@GB1				;Go back if yes
	cmp	AL,'!'				;Is it a bang?
	je	@@GB2				;Stuff it in buffer if yes
	cmp	AL,'+'				;Is it a plus?
	je	@@GB2				;Stuff it in buffer if yes
	cmp	AL,':'				;Is it a colon?
	je	@@GB2				;Stuff it in buffer if yes
	cmp	AL,'#'				;Is it a number sign?
	je	@@GB2				;Stuff it in buffer if yes
	cmp	AL,'*'				;Is it multiply sign?
	je	@@GB2				;Stuff it in buffer if yes
	dec	SI				;Assume log entry
	ret					;And exit routine
@@GB2:	mov	log,AL				;Put priority char in entry
@@GB4:	dec	CX				;Chars = Chars - 1
	lodsb					;Get a character from line
	cmp	AL,blank			;Is it a blank?
	je	@@GB4				;Loop back if yes
	cmp	AL,tab				;Is it a tab character?
	je	@@GB4				;Loop back if yes
	dec	SI				;Else must be entry characters
	ret					;Exit routine

get_bang	endp

	
CSEG	ends

	end	start
